#!/usr/local/bin/perl

#
# JOYFUL NOTE : admin.cgi - 2012/11/28
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# ⥸塼
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;
use Jcode;

# եǧ
require "./init.cgi";
my %cf = &init;

# ǡ
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
&err('̥С') if ($cgi->truncated);
my %in = &parse_form($cgi);

# ǧ
&check_passwd;

# ⡼
&admin_art;

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub admin_art {
	# ե
	if ($in{job} eq "edit" && $in{no}) {

		my @log;
		open(DAT,"$cf{logfile}") or &err("open err: $cf{logfile}");
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ext,$w,$h,$chk) = split(/<>/);

			if ($in{no} == $no) {
				@log = ($name,$eml,$sub,$com,$url,$col,$ext);
				last;
			}
		}
		close(DAT);

		if (@log == 0) { &err("¸ߤޤ"); }

		# ե
		&edit_form(@log);

	# ¹
	} elsif ($in{job} eq "edit2") {

		# 
		if ($in{url} eq 'http://') { $in{url} = ''; }
		$in{sub} ||= '̵';

		# Ѵ
		Jcode::convert(\$in{name},'euc');
		Jcode::convert(\$in{sub},'euc');
		Jcode::convert(\$in{comment},'euc');

		# ǡץ
		my @data;
		open(DAT,"+< $cf{logfile}") or &err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ex,$w,$h,$chk) = split(/<>/);

			if ($no == $in{no}) {

				# 
				if ($in{imgdel}) {
					unlink("$cf{imgdir}/$in{no}$ex");
					$ex = $w = $h = '';
				}
				$_ = "$no<>$reno<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$in{color}<>$ex<>$w<>$h<>$chk<>\n";
			}
			push(@data,$_);
		}

		# 
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 
	} elsif ($in{job} eq "dele" && $in{no}) {

		# 
		my @data;
		open(DAT,"+< $cf{logfile}") or &err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ex,$w,$h,$chk) = split(/<>/);

			# 
			if ($in{no} == $no || $in{no} == $reno) {
				unlink("$cf{imgdir}/$no$ex") if ($ex);
				next;
			}
			push(@data,$_);
		}

		# 
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 
	} elsif ($in{job} eq "perm" && $in{no}) {

		# ľޥå󥰤
		my @data;
		open(DAT,"+< $cf{logfile}") or &err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ex,$w,$h,$chk) = split(/<>/);

			if ($no == $in{no}) {
				if ($chk == 1) { $chk = 0; } else { $chk = 1; }
				$_ = "$no<>$reno<>$date<>$name<>$eml<>$sub<>$com<>$url<>$host<>$pw<>$col<>$ex<>$w<>$h<>$chk<>\n";
			}
			push(@data,$_);
		}

		# 
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	# ɽ
	&header("");
	print <<EOM;
<div align="right">
<form action="$cf{bbs_cgi}">
<input type="submit" value="&lt; Ǽ">
</form>
</div>
<b class="ttl">⡼</b>
<hr class="ttl" size="1">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">

<select name="job">
<option value="edit">Խ
<option value="dele">
EOM

	if ($cf{img_check}) {
		print qq|<option value="perm">\n|;
	}

	print <<EOM;
</select>
<input type="submit" value="">
<dl>
EOM

	open(IN,"$cf{logfile}") or &err("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ex,$w,$h,$chk) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);

		if (!$reno) {
			print "<dt><hr>";
		} else {
			print "<dd>";
		}

		print qq|<input type="radio" name="no" value="$no">[$no]\n|;
		print qq|<b>$sub</b> ̾<b>$name</b> $date\n|;
		if ($ex) {
			print qq|[<a href="$cf{imgurl}/$no$ex" target="_blank">ź</a>]\n|;
			if ($cf{img_check}) {
				if ($chk == 1) {
					print qq|[<span class="grn">ǧ</span>]\n|;
				} else {
					print qq|[<span class="red">̤ǧ</span>]\n|;
				}
			}
		}
		print qq|[$host]\n|;
	}
	close(IN);

	print <<EOM;
<dt><hr>
</dl>
</form>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  ե
#-----------------------------------------------------------
sub edit_form {
	my ($name,$eml,$sub,$com,$url,$col,$ext) = @_;
	$com =~ s/<br>/\n/g;
	$url ||= 'http://';

	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($col == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	&header("⡼ &gt; ե");
	print <<EOM;
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="submit" value="&lt; ">
</form>
<b class="ttl">Խե</b>
<hr class="ttl" size="1">
<p>ѹʬΤ߽ܥ򲡤Ʋ</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="hidden" name="job" value="edit2">
<input type="hidden" name="no" value="$in{no}">
<table class="edit" border="1" cellspacing="0">
<tr>
	<th>̾</th>
	<td><input type="text" name="name" value="$name" size="30"></td>
</tr><tr>
	<th>E-mail</th>
	<td><input type="text" name="email" value="$eml" size="30"></td>
</tr><tr>
	<th>̾</th>
	<td><input type="text" name="sub" value="$sub" size="40"></td>
</tr><tr>
	<th></th>
	<td><textarea name="comment" cols="50" rows="6">$com</textarea></td>
EOM

	if ($ext) {
		print qq|</tr><tr>\n|;
		print qq|<th>ź</th><td>\n|;
		print qq|[<a href="$cf{imgurl}/$in{no}$ext" target="_blank">ź</a>]&nbsp;\n|;
		print qq|<input type="checkbox" name="imgdel" value="1"></td>\n|;
	}

	print <<EOM;
</tr><tr>
	<th>URL</th>
	<td><input type="text" name="url" value="$url" size="50"></td>
</tr><tr>
	<th>ʸ</th>
	<td>$color</td>
</tr>
</table>
<input type="submit" value="">
</form>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  ѥǧ
#-----------------------------------------------------------
sub check_passwd {
	# ѥɤ̤Ϥξϥե
	if ($in{pass} eq "") {
		&enter_form;

	# ѥǧ
	} elsif ($in{pass} ne $cf{password}) {
		&err("ǧڤǤޤ");
	}
}

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub enter_form {
	&header("");
	print <<EOM;
<div align="center">
<form action="$cf{admin_cgi}" method="post">
<table width="380" style="margin-top:50px">
<tr>
	<td height="40" align="center">
		<fieldset><legend>ѥ</legend><br>
		<input type="password" name="pass" value="" size="20">
		<input type="submit" value=" ǧ "><br><br>
		</fieldset>
	</td>
</tr>
</table>
</form>
<script language="javascript">
<!--
self.document.forms[0].pass.focus();
//-->
</script>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  HTMLإå
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print "Content-type: text/html\n\n";
	print <<EOM;
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=EUC-JP">
<meta http-equiv="content-style-type" content="text/css">
<style type="text/css">
<!--
body,td,th { font-size:80%; }
.ttl { color:#00bb00; }
.red { color:red; }
.grn { color:green; }
table.edit { margin-bottom:1em; }
table.edit th,td { padding:5px; }
table.edit th { text-align:left; background:#ccc; }
-->
</style>
<title>$ttl</title>
</head>
<body>
EOM
}

#-----------------------------------------------------------
#  顼
#-----------------------------------------------------------
sub err {
	my $err = shift;

	&header("ERROR");
	print <<EOM;
<div align="center">
<hr width="350">
<h3>ERROR!</h3>
<p class="red">$err</p>
<hr width="350">
</div>
</body>
</html>
EOM
	exit;
}


